Loading...
Searching...
No Matches
Sip_alert_info

## Data Structures

struct | sip_alert_info_s
| Structure for Alert-Info header. More...

## Macros

#define | sip_alert_info(sip)
| Access a SIP Alert-Info header structure sip_alert_info_t from sip_t.
#define | SIP_ALERT_INFO_INIT()
| Initializer for structure sip_alert_info_t.
#define | SIPTAG_ALERT_INFO(x)
| Tag list item for pointer to a Alert-Info header structure sip_alert_info_t.
#define | SIPTAG_ALERT_INFO_REF(x)
| Tag list item for reference to a Alert-Info header pointer.
#define | SIPTAG_ALERT_INFO_STR(s)
| Tag list item for string with Alert-Info header value.
#define | SIPTAG_ALERT_INFO_STR_REF(x)
| Tag list item for reference to a Alert-Info header string.

## Typedefs

typedef struct sip_alert_info_s | sip_alert_info_t
| @

## Functions

issize_t | sip_alert_info_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Alert-Info header.
issize_t | sip_alert_info_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Alert-Info header.
sip_alert_info_t * | sip_alert_info_init (sip_alert_info_t x[1])
| Initialize a structure sip_alert_info_t.
int | sip_is_alert_info (sip_header_t const *header)
| Test if header object is instance of sip_alert_info_t.
sip_alert_info_t * | sip_alert_info_dup (su_home_t *home, sip_alert_info_t const *hdr))
| Duplicate a list of Alert-Info header header structures sip_alert_info_t.
sip_alert_info_t * | sip_alert_info_copy (su_home_t *home, sip_alert_info_t const *hdr))
| Copy a list of Alert-Info header header structures sip_alert_info_t.
sip_alert_info_t * | sip_alert_info_make (su_home_t *home, char const *s))
| Make a Alert-Info header structure sip_alert_info_t.
sip_alert_info_t * | sip_alert_info_format (su_home_t *home, char const *fmt,...)))
| Make a Alert-Info header from formatting result.

## Variables

msg_hclass_t | sip_alert_info_class []
| Header class for Alert-Info header.
tag_typedef_t | siptag_alert_info
| Tag for Alert-Info header object.
tag_typedef_t | siptag_alert_info_str
| Tag for string with Alert-Info header value.

## Detailed Description

## Macro Definition Documentation

## sip_alert_info

#define sip_alert_info | ( |  | sip | ) |

Access a SIP Alert-Info header structure sip_alert_info_t from sip_t.

Since
  New in
  New in 1.12.7.

## SIP_ALERT_INFO_INIT

#define SIP_ALERT_INFO_INIT | ( |  | ) |

Initializer for structure sip_alert_info_t.

A static sip_alert_info_t structure for Alert-Info header must be initialized with the SIP_ALERT_INFO_INIT() macro. For instance,

sip_alert_info_t sip_alert_info = SIP_ALERT_INFO_INIT;
sip_alert_info_t
struct sip_alert_info_s sip_alert_info_t
@
Definition sip_extra.h:62
sip_alert_info
#define sip_alert_info(sip)
Access a SIP Alert-Info header structure sip_alert_info_t from sip_t.
Definition sip_extra.h:554
SIP_ALERT_INFO_INIT
#define SIP_ALERT_INFO_INIT()
Initializer for structure sip_alert_info_t.
Definition sip_extra.h:572

Since
  New in
  New in 1.12.7.

## SIPTAG_ALERT_INFO

#define SIPTAG_ALERT_INFO | ( |  | x | ) |

Tag list item for pointer to a Alert-Info header structure sip_alert_info_t.

The SIPTAG_ALERT_INFO() macro is used to include a tag item with a pointer to a sip_alert_info_t structure in a tag list.

Parameters

  x | pointer to a sip_alert_info_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ALERT_INFO_REF().

Since
  New in
  New in 1.12.7.

## SIPTAG_ALERT_INFO_STR

#define SIPTAG_ALERT_INFO_STR | ( |  | s | ) |

Tag list item for string with Alert-Info header value.

The SIPTAG_ALERT_INFO_STR() macro is used to include a tag item with a string containing value of a sip_alert_info_t header in a tag list.

Parameters

  s | pointer to a string containing Alert-Info header value, or NULL.

The string in SIPTAG_ALERT_INFO_STR() can be converted to a sip_alert_info_t header structure by giving the string s has second argument to function sip_alert_info_make().

The corresponding tag taking reference parameter is SIPTAG_ALERT_INFO_STR_REF().

Since
  New in
  New in 1.12.7.

## Typedef Documentation

## sip_alert_info_t

typedef struct sip_alert_info_s sip_alert_info_t

@

When present in an INVITE request, the Alert-Info header field specifies an alternative ring tone to the UAS. When present in a 180 (Ringing) response, the Alert-Info header field specifies an alternative ringback tone to the UAC. A typical usage is for a proxy to insert this header field to provide a distinctive ring feature.

Alert-Info = "Alert-Info" HCOLON alert-param *(COMMA alert-param)
alert-param = LAQUOT absoluteURI RAQUOT *(SEMI generic-param)

The parsed Alert-Info header is stored in sip_alert_info_t structure.

Since
  New in 1.12.7. In order to use Alert-Info header, initialize the SIP parser before calling nta_agent_create() or nua_create() with, e.g., sip_update_default_mclass(sip_extend_mclass(NULL)).

The sip_t structure does not contain a sip_alert_info field, but sip_alert_info() function should be used for accessing the Alert-Info header structure.

The structure sip_alert_info_t contains representation of an Alert-Info header.

The sip_alert_info_t is defined as follows:

struct sip_alert_info_s
{
sip_common_t ai_common[1]; // Common fragment info
sip_alert_info_t *ai_next; // Link to next @AlertInfo
url_t ai_url[1]; // URI to alert info
msg_param_t const *ai_params; // List of optional parameters
};
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_alert_info_s
Structure for Alert-Info header.
Definition sip_extra.h:68
sip_alert_info_s::ai_url
url_t ai_url[1]
URI to alert info.
Definition sip_extra.h:71
sip_alert_info_s::ai_common
sip_common_t ai_common[1]
Common fragment info.
Definition sip_extra.h:69
sip_alert_info_s::ai_params
msg_param_t const * ai_params
List of optional parameters.
Definition sip_extra.h:72
sip_alert_info_s::ai_next
sip_alert_info_t * ai_next
Link to next Alert-Info.
Definition sip_extra.h:70
url_t

Since
  New in 1.12.7.

## Function Documentation

## sip_alert_info_copy()

sip_alert_info_t * sip_alert_info_copy | ( | su_home_t * | home,
|  | sip_alert_info_t const * | hdr )

inline

Copy a list of Alert-Info header header structures sip_alert_info_t.

The function sip_alert_info_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  alert_info = sip_alert_info_copy(home, sip->sip_alert_info);
  sip_alert_info_copy
  sip_alert_info_t * sip_alert_info_copy(su_home_t *home, sip_alert_info_t const *hdr))
  Copy a list of Alert-Info header header structures sip_alert_info_t.
  Definition sip_extra.h:706

Returns
  A pointer to newly copied header structure, or NULL upon an error.

Since
  New in
  New in 1.12.7.

## sip_alert_info_dup()

sip_alert_info_t * sip_alert_info_dup | ( | su_home_t * | home,
|  | sip_alert_info_t const * | hdr )

inline

Duplicate a list of Alert-Info header header structures sip_alert_info_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  alert_info = sip_alert_info_dup(home, sip->sip_alert_info);
  sip_alert_info_dup
  sip_alert_info_t * sip_alert_info_dup(su_home_t *home, sip_alert_info_t const *hdr))
  Duplicate a list of Alert-Info header header structures sip_alert_info_t.
  Definition sip_extra.h:662

Returns
  A pointer to the newly duplicated sip_alert_info_t header structure, or NULL upon an error.

Since
  New in
  New in 1.12.7.

## sip_alert_info_format()

sip_alert_info_t * sip_alert_info_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Alert-Info header from formatting result.

Make a new sip_alert_info_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_alert_info_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

Since
  New in
  New in 1.12.7.

## sip_alert_info_init()

sip_alert_info_t * sip_alert_info_init | ( | sip_alert_info_t | x[1] | ) |

inline

Initialize a structure sip_alert_info_t.

An sip_alert_info_t structure for Alert-Info header can be initialized with the sip_alert_info_init() function/macro. For instance,

sip_alert_info_t sip_alert_info;
sip_alert_info_init(&sip_alert_info);
sip_alert_info_init
sip_alert_info_t * sip_alert_info_init(sip_alert_info_t x[1])
Initialize a structure sip_alert_info_t.
Definition sip_extra.h:591

Since
  New in
  New in 1.12.7.

## sip_alert_info_make()

sip_alert_info_t * sip_alert_info_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Alert-Info header structure sip_alert_info_t.

The function sip_alert_info_make() makes a new sip_alert_info_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_alert_info_t header structure, or NULL upon an error.

Since
  New in
  New in 1.12.7.

## sip_is_alert_info()

int sip_is_alert_info | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_alert_info_t.

Check if the header class is an instance of Alert-Info header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header alert_info
  0 | (false) otherwise

Since
  New in
  New in 1.12.7.

## Variable Documentation

## sip_alert_info_class

msg_hclass_t sip_alert_info_class[]

extern

Header class for Alert-Info header.

The header class sip_alert_info_class defines how a SIP Alert-Info header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_alert_info_t header structure.

Since
  New in
  New in 1.12.7.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.